# DescribeSecurityGroups

## 1. API Description

This API (DescribeSecurityGroups) is used to query the details of security groups. You can filter the query results with the security group ID or name.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name    | Required | Type            | Description                                                                                            |
| ----------------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------ |
| securityGroupIds  | No       | Array of String | <p>Security group ID(s).</p><p>You can query up to 100 security groups in each request.</p>            |
| securityGroupName | No       | String          | Security group name.                                                                                   |
| pageSize          | No       | Integer         | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Maximum value: 1000.</p> |
| pageNum           | No       | Integer         | <p>Number of pages returned.</p><p>Default value: 1.</p><p>Default value: 1</p>                        |

## 3. Output Parameters

| Parameter Name | Type                                                                                       | Description                                                                                                           |
| -------------- | ------------------------------------------------------------------------------------------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                     | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                                    | Number of security groups meeting the filtering conditions.                                                           |
| dataSet        | Array of [SecurityGroupInfo](/api-reference/compute/vm/datastructure.md#securitygroupinfo) | Information on a security group.                                                                                      |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query all available security groups with no parameter.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeSecurityGroups
<Common Request Params>

Request:
{
  "securityGroupIds": null,
  "securityGroupName": null,
  "pageSize": 5,
  "pageNum": 1
}

Response:
{
  "requestId": "T7977AF93-01C3-4862-A178-03953A4901C3",
  "response": {
    "requestId": "T7977AF93-01C3-4862-A178-03953A4901C3",
    "dataSet": [
      {
        "securityGroupId": "your-sucerity-id",
        "securityGroupName": "123",
        "securityGroupStatus": "Available",
        "createTime": "2022-01-01T01:00:00Z",
        "description": null,
        "instanceIds": [
          "your-instance-id"
        ],
        "ruleInfos": [
          {
            "ruleId": 120,
            "direction": "ingress",
            "policy": "drop",
            "priority": 1,
            "ipProtocol": "all",
            "portRange": "-1/-1",
            "cidrIp": "0.0.0.0/0"
          },
          {
            "ruleId": 124,
            "direction": "ingress",
            "policy": "accept",
            "priority": 1,
            "ipProtocol": "tcp",
            "portRange": "80/80",
            "cidrIp": "0.0.0.0/0"
          }
        ],
        "isDefault": true
      }
    ],
    "totalCount": 1
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/vm/security-group/describesecuritygroups.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
